#ifndef MATRIX_H
#define MATRIX_H

#include "gsl/gsl_matrix.h"

class Matrix {
private:
  gsl_matrix *m;
public:
  Matrix() {
    cout << "Matrix()\n";
    m=gsl_matrix_alloc(3,3);
    gsl_matrix_set_identity(m);
  }
  Matrix(const Matrix& M) {
    cout << "Matrix(M)\n";
    m=gsl_matrix_alloc(3,3);
    gsl_matrix_memcpy(m,M.m);
  }
  ~Matrix() {
    cout << "~Matrix()\n";
    gsl_matrix_free(m);
  }
  Matrix& operator=(const Matrix& M) {
    cout << "operator=()\n";
    if(this!=&M) {
      gsl_matrix_memcpy(m,M.m);
    }
    return *this;
  }
  Matrix operator+(
    const Matrix& B
  ) const {
    cout << "operator+()\n";
    Matrix A(*this);
    gsl_matrix_add(A.m,B.m);
    return A;
  }
  Matrix& Add(
    const Matrix& B
  ) {
    gsl_matrix_add(m,B.m);
    return *this;
  }
  friend ostream& operator<<(
    ostream& out,
    const Matrix& M
  ) {
    gsl_matrix_fprintf(stdout,M.m,"%g");
    return out;
  }
};

#endif
