#include <iostream>
using namespace std;

class Vector {
private:
  const unsigned int dimension;
  double x;
  double y;
public:
  Vector() : dimension(2),x(0.0),y(0.0) {}
  Vector(
    double x_,
    double y_
  ) :
    dimension(2),x(x_),y(y_)
  {}
  Vector(
    const Vector& V
  ) :
    dimension(V.dimension),
    x(V.x),
    y(V.y)
  {}
  ~Vector() {}
  Vector& operator=(const Vector& V) {
    // sabemos que dimension es igual
    x=V.x;
    y=V.y;
    return(*this);
  }
  //   w + v
  Vector operator+(const Vector& V) {
    return Vector(x+V.x,y+V.y);
  }
  // declaracion de metodos no miembros como amigos
  // s * v
private:
  friend Vector operator*(
    double s,
    const Vector& V
  );
  // v * s
  friend Vector operator*(
    const Vector& V,
    double s
  );
public:
  Vector Null(void) const {
    return Vector();
  }
  const Vector ConstNull(void) const {
    return Vector();
  }
  const Vector& Add(
    const Vector& t
  ) {
    x+=t.x;
    y+=t.y;
    return *this;
  }
  const Vector& AddAndChange(
    Vector& t
  );
  unsigned int Dimension(void) const {
    return dimension;
  }
  void Write(void) const {
    cout << "(" << x << "," << y << ")\n";
  }
};

// definicion de metodos amigos
Vector operator*(
  double s,
  const Vector& V
) {
  return Vector(s*V.x,s*V.y);
}

Vector operator*(
  const Vector& V,
  double s
) {
  // return Vector(s*V.x,s*V.y);
  return s*V;
}

const Vector& Vector::AddAndChange(
  Vector& t
) {
  x+=t.x;
  y+=t.y;
  t=Vector();
  return *this;
}

int main(
) {
#ifdef NEVER
  Vector p;
  Vector q0(p.Null());
  q0.Write();

  Vector q1(2.0,3.0);
  p.Null().Add(q1).Write();

  const Vector q2(2.0,3.0);
  // p.Null().AddAndChange(q2).Write();
#endif

  Vector a(1.0,2.0);
  Vector b(1.0,2.0);
  Vector c(a+b);
  c.Write();
  c=c+a;
  c.Write();

  c=5.0*a;
  c.Write();

  c=a*6.0;
  c.Write();

  return 0;
}

